// --------------------------------------------------------------------
// Flood fill with stack
// --------------------------------------------------------------------

import java.awt.Color

class StackFlood(val image: Image) extends Flood {

  val A: Stack[Pixel] = 
    new scala.collection.mutable.Stack[Pixel] with Stack[Pixel]
  var oldCol: Int = _

  def start(p: Pixel) {
    oldCol = image.get(p)
    if (oldCol == 0xff0000)
      return

    image.set(p, 0x00ff00)
    A.push(p)
  }

  def step(): Boolean = {
    if (A.isEmpty)
      true
    else {
      val q = A.pop()
      image.set(q, 0xff0000)
      val nb = image.neighbors(q)
      for (r <- nb) {
	if (image.get(r) == oldCol) {
	  image.set(r, 0x00ff00)
	  A.push(r)
	}
      }
      false
    }
  }
}

// --------------------------------------------------------------------

object FloodFillStack {
  def main(args: Array[String]) {
    val image = new Image("../barba1.png")
    val ui = new UI("Floodfill (stack)", image, new StackFlood(image))
    ui.visible = true
  }
}

// --------------------------------------------------------------------
