// --------------------------------------------------------------------
// Flood fill with queue
// --------------------------------------------------------------------

class QueueFlood extends Flood {

  def flood(im: Image, p: Pixel, color: Int) {
    val oldCol = im.get(p)
    if (oldCol == color)
      return

    val A: Queue[Pixel] = 
      new scala.collection.mutable.Queue[Pixel] with Queue[Pixel]

    im.set(p, color)
    A.enqueue(p)

    while (!A.isEmpty) {
      val q = A.dequeue()
      val nb = im.neighbors(q)
      for (r <- nb) {
	if (im.get(r) == oldCol) {
	  im.set(r, color)
	  A.enqueue(r)
	}
      }
    }
  }
}

// --------------------------------------------------------------------

object FloodFillQueue {
  def main(args: Array[String]) {
    val ui = new UI("Floodfill (queue)", new QueueFlood)
    ui.visible = true
  }
}

// --------------------------------------------------------------------
