// --------------------------------------------------------------------
// Flood fill with recursive method
// --------------------------------------------------------------------

class RecursiveFlood extends Flood {

  private def floodFillRecursive(im: Image, p: Pixel, 
				 oldCol: Int, newCol: Int) {
    im.set(p, newCol)
    val nb = im.neighbors(p)
    for (q <- nb) {
      if (im.get(q) == oldCol)
	floodFillRecursive(im, q, oldCol, newCol)
    }
  }
  
  def flood(im: Image, p: Pixel, color: Int) {
    val oldCol = im.get(p)
    if (oldCol == color)
      return
    floodFillRecursive(im, p, oldCol, color)
  }
}

// --------------------------------------------------------------------

object FloodFillRecursive {
  def main(args: Array[String]) {
    val ui = new UI("Floodfill (recursive)", new RecursiveFlood)
    ui.visible = true
  }
}

// --------------------------------------------------------------------
