// --------------------------------------------------------------------
// Flood fill with stack
// --------------------------------------------------------------------

class StackFlood extends Flood {

  def flood(im: Image, p: Pixel, color: Int) {
    val oldCol = im.get(p)
    if (oldCol == color)
      return

    val A: Stack[Pixel] = 
      new scala.collection.mutable.Stack[Pixel] with Stack[Pixel]

    im.set(p, color)
    A.push(p)

    while (!A.isEmpty) {
      val q = A.pop()
      val nb = im.neighbors(q)
      for (r <- nb) {
	if (im.get(r) == oldCol) {
	  im.set(r, color)
	  A.push(r)
	}
      }
    }
  }
}

// --------------------------------------------------------------------

object FloodFillStack {
  def main(args: Array[String]) {
    val ui = new UI("Floodfill (stack)", new StackFlood)
    ui.visible = true
  }
}

// --------------------------------------------------------------------
